#include "HelloWorldScene.h"
#include "SimpleAudioEngine.h"
#include "CreatorReader.h"

using namespace creator;
USING_NS_CC;

Scene* HelloWorld::createScene()
{
    return HelloWorld::create();
}

// Print useful error message instead of segfaulting when files are not there.
static void problemLoading(const char* filename)
{
    printf("Error while loading: %s\n", filename);
    printf("Depending on how you compiled you might have to add 'Resources/' in front of filenames in HelloWorldScene.cpp\n");
}

// on "init" you need to initialize your instance
bool HelloWorld::init()
{
    //////////////////////////////
    // 1. super init first
    if ( !Scene::init() )
    {
        return false;
    }

	CreatorReader* reader = CreatorReader::createWithFilename("creator/scene/level.ccreator");
	reader->setup();
	Scene* pCreatorScene = reader->getSceneGraph();
	this->addChild(pCreatorScene);

	//buttontouchListenerǵsetSwallowTouchesΪtrueˣtouchֲεЧ
	ui::Button* pBtn = dynamic_cast<ui::Button*>(pCreatorScene->getChildByName("Canvas")->getChildByName("back_button"));
	pBtn->addTouchEventListener(
		[](Ref* sender, ui::Widget::TouchEventType eventType)
	{
		switch (eventType)
		{
		case cocos2d::ui::Widget::TouchEventType::BEGAN:
			CCLOG("%s", "button clicked began");
			break;
		case cocos2d::ui::Widget::TouchEventType::MOVED:
			break;
		case cocos2d::ui::Widget::TouchEventType::ENDED:
			CCLOG("%s", "button clicked ended");
			break;
		case cocos2d::ui::Widget::TouchEventType::CANCELED:
			break;
		default:
			break;
		}
	}
	);
	//עĸõ㴥ִһδĹлᱻ
	auto listener = EventListenerTouchOneByOne::create();
	listener->onTouchBegan = [](Touch*, Event*)->bool{CCLOG("%s", "OneByOne began"); return true; };
	listener->onTouchEnded = [](Touch*, Event*){CCLOG("%s", "OneByOne ended"); };
	_eventDispatcher->addEventListenerWithSceneGraphPriority(listener, this);
    return true;
}


void HelloWorld::menuCloseCallback(Ref* pSender)
{
    //Close the cocos2d-x game scene and quit the application
    Director::getInstance()->end();

    #if (CC_TARGET_PLATFORM == CC_PLATFORM_IOS)
    exit(0);
#endif

    /*To navigate back to native iOS screen(if present) without quitting the application  ,do not use Director::getInstance()->end() and exit(0) as given above,instead trigger a custom event created in RootViewController.mm as below*/

    //EventCustom customEndEvent("game_scene_close_event");
    //_eventDispatcher->dispatchEvent(&customEndEvent);


}
